;;; -*- Mode:Lisp; Syntax:Common-Lisp; Package: -*-
;;; -----------------------------------------------------------------------
;;; File:         gr.l
;;; Description:  System file to load the grammar updated 
;;;               for testing measure, noun-compound, partitive & 
;;;               complex proper 
;;; Author:       Michael Elhadad
;;; Created:      17 Jul 1992
;;; Modified:     18 Jan 93: added adverbial, mood, special & nba (JR)
;;;                5 Jul 95: SURGE 2.2 VERSION
;;; -----------------------------------------------------------------------

(defun reload-gr ()
  "Reload all grammar"
  (let ((cur *default-pathname-defaults*)
	(*warn-if-no-in-package* nil))
    ;; Utilities for temporal patterns  (tpattern unifier)
    (load "tpat.l")
    (load "types.l")
    (load "transitivity.l")
    (load "voice.l")
    (load "adverbial.l")
    (load "clause.l")
    (load "mood.l")
    (load "verb-group.l")
    (load "np.l")
    (load "complex.l")
    (load "determiner.l")
    (load "gr-modular.l")
    (load "special.l")
    (load "nba.l")))

(defun load-gr ()
  "Load missing parts of the grammar"
  (let ((cur *default-pathname-defaults*)
	(*warn-if-no-in-package* nil))
    ;; Utilities for temporal patterns  (tpattern unifier)
    (load "tpat")
    (load "types")
    (load "clause")
    (load "verb-group")
    (load "np")
    (load "determiner")
    (load "complex")
    (load "gr-modular")
    (load "nba")
    (load "special")))
  
(load-gr)


;; ------------------------------------------------------------
;;(provide "$gr/gr")
;; ------------------------------------------------------------





