
// DIDN'T TEST CASE 14-16, THE ONES WITH THE "~" //

/**
 * A class that serves as a test class to try the edu.columbia.surge
 * package.  In this class, some FD examples will be implemented. For
 * each test case, the equivalent lisp implementation and the string
 * created will be provided for users preferrence. When users want to
 * transfer the FDs in lisp to java using this interface, they should
 * work from the bottom of the lisp FD as illustrated below.
 *
 * @author Howard Chu (hhc42)
 * @version alpha 0.1
 */

import edu.columbia.surge.*;
import edu.columbia.surge.hashImpl.*;
import edu.columbia.surge.unifier.*;

public class SurgeTest {

    private static Unifier unifier;

    public static void main(String[] args) {
	UnifierClient client = null;
	if (args.length == 0)
	    client = new UnifierClient();
	else
	    client = new UnifierClient(args[0], 4000);
	
	unifier = new UnifierCache(client);

	client.setLimit(9000);

	System.out.println("1: " + test1());
	System.out.println("2: " + test2());
	System.out.println("3: " + test3());
	System.out.println("4: " + test4());
	System.out.println("5: " + test5());

	System.out.println("1: " + test1());
	System.out.println("2: " + test2());
	System.out.println("4: " + test4());

	System.out.println("6: " + test6());

	System.out.println("7: " + test7());
	System.out.println("8: " + test8());
	System.out.println("9: " + test9());
	System.out.println("10: " + test10());
	System.out.println("11: " + test11());
	System.out.println("12: " + test12());
	System.out.println("13: " + test13());
	System.out.println("17: " + test17());
	System.out.println("18: " + test18());
	System.out.println("19: " + test19());
	System.out.println("5: " + test5());
	System.out.println("20: " + test20());
    }

    /**
     * Result: "The JText."
     * Lisp: ((cat np)
     *        (definite yes)
     *        (lex "JText"))
     * @return the toString representation of the FD
     */
    private static String test1() {
	try {
	    NP JTestNP = NPFactoryH.factory.create("JText");
	    JTestNP.put("definite", FDProperties.DEFINITE);
	    return unifier.unify(JTestNP);
	}
	catch(InvalidConstructorException e) {
	}
	return null;
    }

    /**
     *  Result: "Michael Jordan scored 36 points."
     Lisp: ((cat clause)
     (tense past)
     (proc ((type material)
     (effect-type creative)
     (lex "score")))
     (partic ((agent ((cat proper)
     (head ((cat person-name)
     (first-name ((lex "Michael")))
     (last-name ((lex "Jordan")))))))
     (created ((cat np)
     (cardinal ((value 36)))
     (definite no)
     (head ((lex "point"))))))))
     @return the toString presentation of the FD
    */
    private static String test2() {
	try {
	    NP created = NPFactoryH.factory.create();
	    created.put("definite", FDProperties.NON_DEFINITE);
	    created.putPathOverride("cardinal value", "36");
	    created.putPathOverride("head lex", "point");

	    Proper agent = ProperFactoryH.factory.create();
	    PersonName head = PersonNameFactoryH.factory.create("Michael", null, "Jordan", null, null);
	    agent.put("head", head);

	    Partic partic = ParticFactoryH.factory.create();
	    partic.setAgentCreatedPair(agent, created);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "score", Proc.CREATIVE, true, true,
						    null, null, null);

	    Clause clause = ClauseFactoryH.factory.create(proc, partic, FDProperties.PAST_TENSE,
							  null, null, null, null, false, null, null, null, null);

	    return unifier.unify(clause);
	}
	catch(InvalidConstructorException e) {
	}
	catch(InvalidPathException e) {
	}
	return null;
    }

    /**
       "Howard squats."
       ((cat clause)
       (proc ((type material)
       (agentive yes)
       (effective no)
       (effect-type simple)
       (lex "squat")))
       (partic ((agent ((cat proper) (lex "Howard"))))))
       @return @return the toString presentation of the FD
    */
    private static String test3() {
	try {
	    Proper agent = ProperFactoryH.factory.create("Howard");
	    Partic partic = ParticFactoryH.factory.create("agent", agent);
	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "squat", Proc.SIMPLE, true,
						    false, null, null, null);
	    Clause clause = ClauseFactoryH.factory.create(proc, partic);
	    return unifier.unify(clause);
	}
	catch(Exception e) {
	}
	return null;
    }

    /**
       "Michael takes a shower."
       ((cat clause)
       (proc ((type material)
       (effective no)
       (agentive yes)
       (event-as process)
       (lex "take")))
       (partic ((agent ((cat proper)
       (lex "Michael")))
       (range ((definite no)
       (lex "shower"))))))
       @return the toString presentation of the FD
    */
    private static String test4() {
	try {
	    FD range = FDFactoryH.factory.create();
	    range.put("definite", "no");
	    range.put("lex", "shower");

	    Proper agent = ProperFactoryH.factory.create("Michael");

	    Partic partic = ParticFactoryH.factory.create();
	    partic.setAgentRangePair(agent, range);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "take", null, true, false, null, null, null);
	    proc.put("event-as", "process");

	    Clause clause = ClauseFactoryH.factory.create(proc, partic);

	    return unifier.unify(clause);
	}
	catch(Exception e) {
	}
	return null;
    }

    /**
       "I can not position it in an inactive document."
       ((cat clause)
       (epistemic-modality possible)
       (proc ((type composite)
       (polarity negative)
       (agentive yes)
       (relation-type locative)
       (effective yes)
       (lex "position")))
       (partic ((agent ((cat personal-pronoun) (person first)))
       (location ((cat pp)
       (prep === "in")
       (np ((cat common)
       (definite no)
       (describer === "inactive")
       (head === "document")))))
       @return the toString() representation of the FD
    */
    private static String test5() {
	try {
	    Common np = CommonFactoryH.factory.create("document");
	    np.put("definite", FDProperties.NON_DEFINITE);
	    np.put("describer", "inactive");
	    PP location = PPFactoryH.factory.create("in", np);
	    PersonalPronoun agent = PersonalPronounFactoryH.factory.create(PersonalPronoun.FIRST);
	    Partic partic = ParticFactoryH.factory.create("agent", agent, "location", location);

	    Proc proc = ProcFactoryH.factory.create(Proc.COMPOSITE, "position", null, true, true, null,
						    Proc.LOCATIVE, FDProperties.NEGATIVE_POLARITY);

	    Clause clause = ClauseFactoryH.factory.create(proc, partic);
	    clause.put("epistemic-modality", "possible");

	    return unifier.unify(clause);
	}
	catch(Exception e) {
	}
	return null;
    }

    /**
     * "I can not position in an inactive document."
     ((cat clause)
     (epistemic-modality possible)
     ;(common ((mood imperative)))
     ;(mood imperative)
     (proc ((type material)
     (polarity negative)
     (agentive yes)
     (effective yes)
     (lex "position")))
     (partic ((agent ((cat personal-pronoun) (person first)))
     (affected ((cat pp)
     (prep === "in")
     (np ((cat common)
     (definite no)
     (describer === "inactive")
     (head === "document"))))))))
     @return the toString() representation of the FD
    */
    private static String test6() {
	try {
	    Common np = CommonFactoryH.factory.create("document");
	    np.put("definite", FDProperties.NON_DEFINITE);
	    np.put("describer", "inactive");
	    PP location = PPFactoryH.factory.create("in", np);
	    PersonalPronoun agent = PersonalPronounFactoryH.factory.create(PersonalPronoun.FIRST);
	    Partic partic = ParticFactoryH.factory.create("agent", agent, "location", location);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "position", null, true, true, null,
						    null, FDProperties.NEGATIVE_POLARITY);

	    Clause clause = ClauseFactoryH.factory.create(proc, partic);
	    clause.put("epistemic-modality", "possible");

	    return unifier.unify(clause);
	}
	catch(Exception e){
	}
	return null;
    }

    /**
     * "Do not position in an inactive document."
     ((cat clause)
     (polarity negative)
     (mood imperative)
     (proc ((type material) (lex "position")))
     (partic ((agent ((cat personal-pronoun) (person second)))
     (affected ((cat pp)
     (prep === "in")
     (np ((cat common)
     (definite no)
     (describer === "inactive")
     (head === "document"))))))))
     @return the toString() representation of the FD
    */
    private static String test7() {
	try {
	    Common np = CommonFactoryH.factory.create("document");
	    np.put("definite", FDProperties.NON_DEFINITE);
	    np.put("describer", "inactive");
	    PP affected = PPFactoryH.factory.create("in", np);
	    PersonalPronoun agent = PersonalPronounFactoryH.factory.create(PersonalPronoun.SECOND);

	    Partic partic = ParticFactoryH.factory.create();
	    partic.setAgentAffectedPair(agent, affected);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "location");

	    Clause clause = ClauseFactoryH.factory.create(proc, partic, null, null, FDProperties.IMPERATIVE_MOOD,
							  null, null, false, null, null, null, null);
	    clause.setPolarity(FDProperties.NEGATIVE_POLARITY);

	    return unifier.unify(clause);
	}
	catch(Exception e) {
	}
	return null;
    }

    /**
     * "I can not position it in an inactive document."
     ((cat clause)
     (epistemic-modality possible)
     (proc ((type composite)
     (polarity negative)
     (agentive yes)
     (relation-type locative)
     (effective yes)
     (lex "position")))
     (partic ((agent ((cat personal-pronoun) (person first)))
     (location ((cat pp)
     (prep === "in")
     (np ((cat common)
     (definite no)
     (describer === "inactive")
     (head === "document")))))
     @return the toString() representation of the FD
    */
    private static String test8() {
	try {
	    Common np = CommonFactoryH.factory.create("document");
	    np.put("definite", FDProperties.NON_DEFINITE);
	    np.put("describer", "inactive");
	    PP location = PPFactoryH.factory.create("in", np);
	    PersonalPronoun agent = PersonalPronounFactoryH.factory.create(PersonalPronoun.FIRST);

	    Partic partic = ParticFactoryH.factory.create();
	    partic.setAgentLocationPair(agent, location);

	    Proc proc = ProcFactoryH.factory.create(Proc.COMPOSITE, "position", null, true, true, null,
						    Proc.LOCATIVE, FDProperties.NEGATIVE_POLARITY);

	    Clause clause = ClauseFactoryH.factory.create(proc, partic);
	    clause.put("epistemic-modality", "possible");

	    return unifier.unify(clause);
	}
	catch(Exception e) {
	}
	return null;
    }

    /**
     * "JBrowse reflects the contents of a different document."
     ((cat clause)
     (proc ((type material)
     (effective-type dispositive)
     (lex "reflect")))
     (partic ((agent ((cat proper) (lex "JBrowse")))
     (affected ((cat common)
     (definite yes)
     (number plural)
     (lex "content")))))
     (circum ((behalf ((cat pp)
     (prep === "of")
     (np ((cat common)
     (definite no)
     (describer === "different")
     (head === "document"))))))))
     @return the toString representation of the FD
    */
    private static String test9() {
	try {
	    Common np = CommonFactoryH.factory.create("document");
	    np.put("definite", "no");
	    np.put("describer", "different");
	    PP behalf = PPFactoryH.factory.create("of", np);
	    Circum circum = CircumFactoryH.factory.create(behalf, null, null, null, null, null, null, null);

	    Proper agent = ProperFactoryH.factory.create("JBrowse");
	    Common affected = CommonFactoryH.factory.create("content");
	    affected.put("definite", FDProperties.DEFINITE);
	    affected.put("number", FDProperties.PLURAL);
	    Partic partic = ParticFactoryH.factory.create();
	    partic.setAgentAffectedPair(agent, affected);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "reflect", Proc.DISPOSITIVE, true, true, null,
						    null, null);

	    Clause clause = ClauseFactoryH.factory.create(proc, partic, null, null, null, null, null, false,
							  circum, null, null, null);

	    return unifier.unify(clause);
	} catch(Exception e) {
	}
	return null;
    }

    /**
     * "Default options for future sessions."
     ((cat common)
     (describer ((cat adj) (lex "Default")))
     (definite no)
     (number plural)
     (head === "option")
     (qualifier ((cat pp)
     (prep ((lex "for")))
     (np ((cat common)
     (definite no)
     (describer ((cat adj) (lex "future")))
     (number plural)
     (head ((lex "session"))))))))
     @return the toString representation of the FD
    */
    private static String test10() {
	try {
	    Common np = CommonFactoryH.factory.create("session");
	    np.put("definite", FDProperties.NON_DEFINITE);
	    np.putPathOverride("describer cat", "adj");
	    np.putPathOverride("describer lex", "future");
	    np.put("number", FDProperties.PLURAL);
	    PP qualifier = PPFactoryH.factory.create("for", np);

	    Common common = CommonFactoryH.factory.create("option");
	    common.putPathOverride("describer cat", "adj");
	    common.putPathOverride("describer lex", "Default");
	    common.put("definite", "no");
	    common.put("number", "plural");
	    common.put("qualifier", qualifier);

	    return unifier.unify(common);
	} catch(Exception e) {
	}
	return null;
    }

    /**
     * "Display the status bar."
     ((cat clause)
     (mood imperative)
     (proc ((type material)
     (lex "display")))
     (partic ((affected ((cat common)
     (describer === "status")
     (head === "bar"))))))
     * @return the toString representation of the FD
     */
    private static String test11() {
	try {
	    Common affected = CommonFactoryH.factory.create("bar");
	    affected.put("describer", "status");
	    Partic partic = ParticFactoryH.factory.create("affected", affected);

	    Proc proc = ProcFactoryH.factory.create(Proc.MATERIAL, "display");

	    Clause clause = ClauseFactoryH.factory.create(proc, partic, null, null, FDProperties.IMPERATIVE_MOOD,
							  null, null, false, null, null, null, null);

	    return unifier.unify(clause);
	} catch(Exception e) {
	}
	return null;
    }

    /**
       "Method throws types."
       ((cat clause)
       (proc ((type material)
       (lex throw)))
       (partic ((agent ((cat proper) (lex "Method")))
       (affected ((number plural)
       (definite no)
       (lex "type"))))))
       * @return the toString representation of the FD
       */
    private static String test12() {
        try {
            FD affected = new FDH();
            affected.put("number", FDProperties.PLURAL);
            affected.put("definite", "no");
            affected.put("lex", "type");
            Proper agent = new ProperH("Method");
            Partic partic = new ParticH();
            partic.setAgentAffectedPair(agent, affected);

            Proc proc = new ProcH(Proc.MATERIAL, "throw");

            Clause clause = new ClauseH(proc, partic);

            return unifier.unify(clause);
        } catch(Exception e) {
        }
        return null;
    }

    /**
     * "The lowest visibility level."
     ((cat common)
     (definite yes)
     (describer ((cat adj) (lex "lowest")))
     (classifier ((cat noun) (lex "visibility")))
     (head === "level"))
     * @return the toString representation of the FD
     */
    private static String test13() {
        try {
            Common common = new CommonH("level", true);
            common.putPathOverride("describer cat", "adj");
            common.putPathOverride("describer lex", "lowest");
            common.putPathOverride("classifier cat", "noun");
            common.putPathOverride("classifier lex", "visibility");

            return unifier.unify(common);
        } catch(Exception e) {
        }
        return null;
    }

    /**
     * "The implementation detail modifiers."
     ((cat common)
     (definite yes)
     (describer === "implementation")
     (classifier ((cat noun) (lex "detail")))
     (number plural)
     (head === "modifier"))
     * @return the toString representation of the FD
     */
    private static String test17() {
        try {
            Common common = new CommonH("modifier", true);
            common.put("describer", "implementation");
            common.putPathOverride("classifier cat", "noun");
            common.putPathOverride("classifier lex", "detail");
            common.put("number", FDProperties.PLURAL);

            return unifier.unify(common);
        } catch(Exception e) {
        }
        return null;
    }

    /**
     * "The keywords which are specified by icons."
       
       ((cat common)
        (head === "keyword")
        (number plural)
        (qualifer ((cat clause)
	           ; (restrictive yes)
	           (proc ((type composite)
		          (relation-type possessive)
		          (voice passive)
		          (lex "specify")))
	           (dative-move no)
	           (scope {^ partic affected})
	           (partic ((agent ((cat noun)
			            (number plural)
			            (lex "icon"))))))))
     * @return the toString representation of the FD
     */
    private static String test18() {
	try {
	    FD agent = new FDH();
	    agent.put("cat", "noun");
	    agent.put("number", FDProperties.PLURAL);
	    agent.put("lex", "icon");
	    Partic partic = new ParticH("agent", agent);
	    Proc proc = new ProcH(Proc.COMPOSITE, "specify");
	    proc.setRelationType(Proc.POSSESSIVE);
	    proc.put("voice", "passive");
	    String[] scope = {"partic", "affected"};
	    Clause qualifier = new ClauseH(proc, partic, null, null, null, null, null, false, null, null, scope, null);
	    qualifier.put("dative-move", "no");

	    Common common = new CommonH("keyword");
	    common.put("number", "plural");
	    common.put("qualifier", qualifier);

	    return unifier.unify(common);
	} catch(Exception e) {
	}
	return null;
    }

    /**
     * "The book that is a classic."
     ((cat common)
     (head === "book")
     (animate no)
     (qualifier ((cat clause)
     (restrictive yes)
     (proc ((type ascriptive)))
     (scope {^ partic carrier})
     ;; (scope ((role carrier)))
     (partic ((attribute ((cat common)
     (definite no)
     (lex "classic"))))))))
     * @return the toString representation of the FD
     */
    private static String test19() {
	try {
	    Common attribute = new CommonH("classic", false);
	    Partic partic = new ParticH("attribute", attribute);
	    Proc proc = new ProcH();
	    proc.setProcessType(Proc.ASCRIPTIVE);
	    proc.setRelationType(Proc.POSSESSIVE);
	    String[] scope = {"partic", "carrier"};
	    Clause qualifier = new ClauseH(proc, partic, null, null, null, null, null, true, null, null, scope, null);

	    Common common = new CommonH("book");
	    common.put("animate", "no");
	    common.put("qualifier", qualifier);

	    return unifier.unify(common);
	} catch(Exception e) {
	}
	return null;
    }

    /**
     * "Pablo gives a book to Howard."
     ((cat clause)
     (proc ((type composite)
     (relation-type possessive)
     (mode attributive)
     (agentive yes)
     (effective yes)
     (effect-type dispositive)
     (dative-prep "to")
     (lex "give")))
     (dative-move no)
     (partic ((agent ((cat proper) (lex "Pablo")))
     (affected ((cat proper) (lex "Howard")))
     (possessor {^ affected})
     (possessed ((lex "book")
     (cat common)
     (definite no))))))
     * @return the toString representation of the FD
     */
    private static String test20() {
	try {
	    Common possessed = new CommonH("book", false);
	    Proper affected = new ProperH("Howard");
	    Proper agent = new ProperH("Pablo");
	    Partic partic = new ParticH();
	    partic.setAgentAffectedPair(agent, affected);
	    partic.setPossessorPossessedPair(affected, possessed);

	    Proc proc = new ProcH(Proc.COMPOSITE, "give", Proc.DISPOSITIVE, true, true, Proc.ATTRIBUTIVE_MODE,
				  Proc.POSSESSIVE, null);
	    proc.put("dative-prep", "to");

	    Clause clause = new ClauseH(proc, partic);
	    clause.put("dative-move", "no");

	    return unifier.unify(clause);
	} catch(Exception e) {
	    System.out.println("fail");
	}
	return null;
    }
}
