/*
 * @(#)AP.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The AP category for a FD. This is the adjective phrase and can be
 * used anywhere to describe an object or an action. Methods are
 * provided to set the head of the AP either in the form of String or
 * FD. Factory methods are also provided for easier constructing
 * purpose. User should either use the setLex or the sethead method to
 * set the object of the AP. It will not make sense if user uses both
 * methods for the same AP FD.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see APFactory
 */

public interface AP extends FD {
    /**
     * A method to set the lexical entry of the AP
     * @param lex the lexical entry of the AP
     */
    public void setLex(String lex);

    /**
     * A method to set the headw of the AP. This is used when the head
     * cannot be represented by a single word. Otherwise, use setLex()
     * instead.
     * @param head a FD representation of the head
     */
    public void setHead(FD head);
}
