/*
 * @(#)FDFactory.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This class holds the factory methods for the FD class. Users can
 * use this class to create instances of FD objects with their desired
 * parameters.
 */

public interface FDFactory {
    /**
     * The static instance which helps users to access to the methods in
     * this class.
     */
    public static FDFactory factory = null;

    /**
     * A factory method which creates a default instance of FD.
     * @return a default instance of FD
     */
    public FD create();
}
