/*
 * @(#)FDNullFactory.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This class holds the factory methods for the FDNull class. Users
 * can use this class to create instances of FDNull objects with their
 * desired parameters.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see FDNull
 */

public interface FDNullFactory {

    /**
     * The static instance which helps users to access to the methods in
     * this class.
     */
    public static FDNullFactory factory = null;

    /**
     * A factory method which creates a default instance of FDNull.
     * @return a default instance of FDNull
     */
    public FDNull create();
}
