/*
 * @(#)FDRef.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * FDRef is used to compose the scope statement for a clause during
 * the unification process.  A FDRef object stores a referrence of the
 * hole that a user specifies. Each FDRef object either stores a
 * reference of a FDNull object or a FD object. During the
 * unification, the path of the FD or FDNull object is set in the
 * scope statement. FDRef objects are used by the setRef methods in
 * the clause class in order to set the scope and the hole in a
 * clause.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see FDRefFactory
 * @see FDNull
 * @see FD
 */

public interface FDRef extends FD {
  /**
   * A method that returns the referrence object stored.
   * @return the reference object
   */
  public Object getRef();
}
