/*
 * @(#)FDRefFactory.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This class holds the factory methods for the FDRef class. Users can
 * use this class to create instances of FDRef objects with their
 * desired parameters.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see FDRef
 */

public interface FDRefFactory {

    /**
     * The static instance which helps users to access to the methods in
     * this class.
     */
    public static FDRefFactory factory = null;

    /**
     * A factory method which creates an instance of FDRef with the
     * given object to be referrenced to as the hole.
     * @param ref the hole of the FD, it is either a FD or a FDNull object.
     * @return a default instance of FD
     */
    public FDRef create(Object ref);
}
