/*
 * @(#)InvalidConstructorException.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This exception is thrown when users feed in an invalid constructor
 * arguments when creating FDs.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 */

public class InvalidConstructorException extends Exception {
  /**
   * Constructor which creates a default instance of the
   * InvalidConstructorExcepion.
   */
  public InvalidConstructorException() {
    super();
  }

  /**
   * Constructor that creates an instance of
   * InvalidConstructorException with the specified exception message.
   * @param message the user-defined message.
   */
  public InvalidConstructorException(String message) {
    super();
    this.message = message;
  }

  /**
   * Override the inherrited toString method. It returns the default
   * message together with the user-defined message(if any).
   * @return the message gives when the exception is thrown.
   */
  public String toString() {
    return DEFAULT_MESSAGE + message;
  }

  /**
   * The default exception message.
   */
  private static final String DEFAULT_MESSAGE = "Invalid Constructor Arguments. ";

  /**
   * The user specified exception message.
   */
  private String message;
}
