/*
 * @(#)NP.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The NP category for a FD. Methods are provided to set the head and
 * the lex of the noun phrase. Users should only set either the head
 * or the lexical entry for each noun phrase, it does not make sense
 * to set both of them at the same time.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 * 
 * @see NPFactory
 */

public interface NP extends FD {
  /**
   * A method to set the head of the NP
   * @param head a FD representation of the head
   */
   public void setHead(FD head);

   /**
    * A method to set the lex of the NP
    * @param lex
    */
   public void setLex(String lex);
}
