/*
 * @(#)PP.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The PP (prepositional phrase) category for a FD. Methods are
 * provided to set the preposition and the np (noun phrase) which is
 * essential in creating PPs. Factory methods are also provided for
 * easier constructing purpose.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PPFactory
 * @see NP
 */

public interface PP extends FD {
  /**
   * A method to set the preposition of a prepositional phrase
   * @param preposition
   */
   public void setPrep(String preposition) throws InvalidPathException;

   /**
    * A method to set the NP within a PP
    * @param NP
    */
   public void setNP(FD np);
}
