/*
 * @(#)PPFactory.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This class holds the factory methods for the PP class. Users can
 * use this class to create instances of PP objects with their
 * desired parameters.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PP
 */

public interface PPFactory {
    /**
     * The static instance which helps users to access to the methods in
     * this class.
     */
    public static PPFactory factory = null;

    /**
     * A factory method which creates a default instance of PP.
     * @return a default instance of PP
     */
    public PP create();

    /**
     * A factory method which returns a PP object with the input
     * preposition and the body of the NP which resides in the
     * prepositional phrase.
     * @param prep the preposition of the PP
     * @param np the NP within the PP
     * @return a PP object which has the properties of the given
     * parameters
     */
    public PP create(String prep, FD np) 
	throws InvalidConstructorException, InvalidPathException;
}
