/*
 * @(#)PersonalName.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The person-name category. This is often used when user wants to
 * specify a person with his/her name and title. A person-name
 * category can be used independently or used as the head of a FD.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PersonNameFactory
 */
public interface PersonName extends FD {
    /**
     * A method to set the first name of the person
     * @param firstName
     */
    public void setFirstName(String firstName) throws InvalidPathException;

    /**
     * A method to set the last name of the person
     * @param lastName
     */
    public void setLastName(String lastName) throws InvalidPathException;

    /**
     * A method to set the middle name of the person
     * @param middleName
     */
    public void setMiddleName(String middleName) throws InvalidPathException;

    /**
     * A method to set the nickname of the person
     * @param nickName
     */
    public void setNickName(String nickName) throws InvalidPathException;

    /**
     * A method to set the title of the person
     * @param title
     */
    public void setTitle(String title) throws InvalidPathException;
}
