/*
 * @(#)PersonNameFactory.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * This class holds the factory methods for the PersonName
 * class. Users can use this class to create instances of PersonName
 * objects with their desired parameters.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PersonName
 */

public interface PersonNameFactory {
    /**
     * The static instance which helps users to access to the methods in
     * this class.
     */
    public static PersonNameFactory factory = null;

    public PersonName create();

    public PersonName create(String firstName, String middleName, 
			     String lastName, String nickName, 
			     String title) 
	throws InvalidConstructorException, InvalidPathException;
}
