/*
 * @(#)PreMod.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The pred-modif category. This class is also often used together
 * within a clause together with the Clause, Proc, Partic and
 * possibly, the Circum class. This class serves to define the
 * predefined modifier to further describe the process of a clause.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PreModFactory
 * @see Clause
 * @see Proc
 * @see Partic
 * @see Circum
 */

public interface PreMod extends FD {
  /**
   * A method to set the instrument of the pred-modif
   * @param instrument specified in the form of a FD
   */
  public void setInstrument(FD instrument);
}
