/*
 * @(#)Proper.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge;

/**
 * The proper category. This is usually used when user wants to
 * specify a name of a person. The lexical entry in the proper
 * category is usually the name, which is the proper noun
 * itself. There are methods to set the proper noun and also the
 * plurality of the noun. A factory method is available to construct a
 * Proper object in a more convenient fashion.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see ProperFactory
 */

public interface Proper extends FD {
    /**
     * A method to set the lex/proper noun of the proper category.
     * @param lex the proper noun
     */
    public void setLex(String lex);

    /**
     * A method to set the plurality of the proper noun.
     * @param plurality set true to be plural and false to be singular
     */
    public void setPlurality(boolean plurality);
}
