/*
 * @(#)FDRefH.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge.hashImpl;
import edu.columbia.surge.*;

/**
 * This class is inherrited from the FDH class and implements the
 * FDRef interface.  User creates instances of this class whenever
 * they want to specify a hole in a FD, it has one instance variable
 * which will store the hole of a FD. During the unification process,
 * the path of the hole stored will be included in the set statement.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see FDH
 * @see FDNull
 * @see FDRef
 */

public class FDRefH extends FDH implements FDRef {
    /**
     * A variable to store the hole of a FD
     */
    protected Object ref;

    /**
     * Constructor. It takes in a ref, i.e., the hole of the clause
     * and stores it.
     * @param ref the hole object
     */
    public FDRefH(Object ref) {
	this.ref = ref;
    }

    /**
     * A method that returns the referrence object stored.
     * @return the reference object
     */
    public Object getRef() {
	return ref;
    }
}
