/*
 * @(#)PersonNameFactoryH.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge.hashImpl;
import edu.columbia.surge.*;

/**
 * This class contains an implementation of factory methods for
 * PersonNames.
 *
 * @author Howard Chu (hhc42@columbia.edu)
 * @version alpha 0.1
 *
 * @see PersonNameH
 */

public class PersonNameFactoryH implements PersonNameFactory {

    public static PersonNameFactoryH factory;

    private PersonNameFactoryH() {}

    static {
	factory = new PersonNameFactoryH();
    }

    public PersonName create() {
	return new PersonNameH();
    }

    public PersonName create(String firstName, String middleName, 
			     String lastName, String nickName, 
			     String title) 
	throws InvalidConstructorException, InvalidPathException {
	return new PersonNameH(firstName, middleName, lastName, nickName, 
			       title);
    }
}
