/*
 * @(#)PersonNameH.java alpha0.1
 *
 * Copyright 2002 Columbia University, All Rights Reserved.
 *
 * This software is distributed under the LGPL.
 *
 */

package edu.columbia.surge.hashImpl;
import edu.columbia.surge.*;

/**
 * Person name implementation class.
 *
 * @author Howard Chu (hhc42)
 * @version 1.0
 */


public class PersonNameH extends FDH implements PersonName {
    public PersonNameH() {
	super();
	this.put("cat", "person-name");
    }

    /**
     * Constructor. It must specify at least one name, otherwise an
     * exception will be thrown.
     */
    public PersonNameH(String firstName, String middleName, String lastName,
		       String nickName, String title) 
	throws InvalidConstructorException, InvalidPathException {
	try {
	    this.put("cat", "person-name");

	    if( (firstName == null || firstName.equals("")) && 
		(middleName == null || middleName.equals("")) &&
		(lastName == null || lastName.equals("")) && 
		(nickName == null || nickName.equals("")) &&
		(title == null || title.equals("")) )
		throw new InvalidConstructorException("No mame is specified.");

	    if(firstName != null && !firstName.equals(""))
		this.setFirstName(firstName);

	    if(middleName != null && !middleName.equals(""))
		this.setMiddleName(middleName);

	    if(lastName != null && !lastName.equals(""))
		this.setLastName(lastName);

	    if(nickName != null && !nickName.equals(""))
		this.setNickName(nickName);

	    if(title != null && !title.equals(""))
		this.setTitle(title);
	}
	catch(InvalidPathException e) {
	}
    }

    public void setFirstName(String firstName) throws InvalidPathException {
	try {
	    this.putPathOverride("first-name lex", firstName);
	} catch(InvalidPathException e) {
	}
    }

    public void setMiddleName(String middleName) throws InvalidPathException {
	try {
	    this.putPathOverride("middle-name lex", middleName);
	} catch(InvalidPathException e) {
	}
    }

    public void setLastName(String lastName) throws InvalidPathException {
	try {
	    this.putPathOverride("last-name lex", lastName);
	} catch(InvalidPathException e) {
	}
    }

    public void setNickName(String nickName) throws InvalidPathException {
	try {
	    this.putPathOverride("nickname lex", nickName);
	} catch(InvalidPathException e) {
	}
    }

    public void setTitle(String title) throws InvalidPathException {
	try {
	    this.putPathOverride("title lex", title);
	} catch(InvalidPathException e) {
	}
    }
}
